% Nicotine addiction for ICANN 2010
% Uda is driven by n-s-c loop

clear all, close all, clc

global a   %this 'a' is the 'a' in tanh(ax) in the activation function
global n_loop %the number of the loops for different inputs.Here it is 3
global W_r
global initial%the initial conditions of the premotor and motor units in
global pp%To be used in actor.m. These are the value of cortex and striatum 
global rr%in premotor loops,which will be used for changing W_r

a=3;

%Some program outputs for the beginning
first_column='action'
second_column='W_r'
third_forth_fifth_column='W_cs'
sixth_column='W_v(the values)'
seventh_column='reward,the number of succesfuly completed consecutive time steps'
press='a button'
pause

n_loop=2;
mu=0.1;% the discount factor in reinforcement learning
mu_v=0.1;% learning rate for value function
mu_c=0.1;% learning rate for association matrix
mu_r=0.1;% learning rate for W_r weights in Basal Ganglia
mu_da=0.1;% learning rate for Uda in dopamine system

mu_1=0.1;   % learning rate for U_1
mu_2=0.1;   % learning rate for U_2
mu_w=0.1;   % learning rate for w_ii

W_r=0.5*ones(n_loop,1);

okey=0;

Y1=[1 0]';% desired outputm smoke
Y2=[0 1]';% desired output do not smoke
Y=[Y1 Y2];


W_c=0.1+0.5*rand(n_loop,n_loop);% association matrix
W_v=0.01*rand(1,2)%[0 0 0];% linear value function
base=0.2%base value for the value function
V(1)=W_v*[0.1 0.1]';% output of the value function
numberoftest=1000
kk=0;

nicotine=0.1; %0.2
theta_da=0.1*nicotine;
ri=0.01;       %initially smoking is not a reward

Udaa(:,1)=0.1*rand(n_loop,1);   %dopamine system init value
%Udaa(:,1)=0.1*rand(1,1);   %dopamine system init value

t_A=1;     % A-S time constant
t_w=1;     % learning rate time constant

%%%%%rates%%%%
tho_n=0.25;
tho_s=1;
tho_c=2;

n=0.2     % fastest process init value
s=0.2     % slow process init value
c=0.2     % slowest process init value
%%%%%%parameters%%%%
theta_n=0.6%0.1;
theta_s=0.7%0.1;
theta_c=0.7%0.1;
beta_s=0.4%0.2;
beta_c=0.4%0.2;

% degisim anlarindaki (okey=10) W degerlerini tut
W_diffs = zeros(1,9);
Wdi=1;
kf=1;       % movie frame index

for k=1:numberoftest
    days=1000;
	for i=1:days
        if  i< (days/2)
            if k==1
                drug=0.03;
            else
                drug=0.3*action(1,1);
            end            
        else
            drug=0;
        end
	
        alpha_n(i)=0.5*(1+tanh(drug-theta_n));
        alpha_s(i)=0.5*(1+tanh(n(i)-theta_s));
        alpha_c(i)=0.5*(1+tanh(s(i)-theta_c));
        beta_n(i)=0.5*(1+tanh(c(i)-theta_n));
        n(i+1)=n(i)+mu*(1/tho_n)*(-beta_n(i)*c(i)+alpha_n(i)*(1-n(i)*c(i)));
        s(i+1)=s(i)+mu*(1/tho_s)*(-beta_s*s(i)+alpha_s(i)*(1-s(i)));
        c(i+1)=c(i)+mu*(1/tho_c)*(-beta_c*c(i)+alpha_c(i)*(1-c(i)));
        
        
%         figure(3)
%         hold on
%         plot(days,drug,'ks','Color',[.6 .6 .6])
	end   

	NN=n((days/2)+1)*s((days/2)+1);        % total nAChR signal when nicotine uptaking stops
	theta_da=0.1*NN;


    kk=kk+1;
    
    initial=0.1*rand(n_loop,10);
    I(:,kk)=[0.1 0.1]';
    if k==1                         % smoking action from previous loop is used for value assignment
        V(kk)=(W_v+base)*I(:,kk);
        II(:,kk)=W_c*I(:,kk);
        action(:,kk)=actor_bagimlilik(II(:,kk));% actor.m has two parts, namely premotor and motor loops 
    %pause
    else
        V(kk)=(W_v+base)*action(:,kk-1);
        II(:,kk)=W_c*action(:,kk-1);
        action(:,kk)=actor_bagimlilik(II(:,kk));% actor.m has two parts, namely premotor and motor loops 
    end  
    if action(:,kk)==Y(:,1)
        ri=ri*2;
        if ri >= 1
            ri=1;
        end
    end

    if action(:,kk)==Y(:,1)
        input='sigara ic"';
        okey=okey+1;
    end
    if action(:,kk)==Y(:,2)
        input='sigara icme"';
        okey=0;
    end
    if action(:,kk)==[1,1]'
        input='kararsiz"';
        okey=0;
    end
    okey
%     figure(4)
%     hold on
%     plot(k,okey/10,'.r','LineWidth',3);
%     % F_delta(kk)=getframe;

    I(:,kk+1)=[0.1 0.1]';
    V(kk+1)=(W_v+base)*I(:,kk+1);
    delta(kk)=ri+mu*V(kk+1)-V(kk);
    if ri>=0.5
        W_v=W_v+mu_v*delta(kk)*action(:,kk)';
    end
   
    for ii=1:2 
        if W_v(ii)<0
            W_v(ii)=0;
        end
    end
    V(kk+1)=(W_v+base)*action(:,kk);
    
    sda=0.5*(1+tanh((NN*ri)-theta_da));
    %sda=0.5*(1+tanh((nicotine*ri)-theta_da));
    iter=100;
    for uii=1:iter
        Udaa(:,uii+1)=Udaa(:,uii)+mu_da*(-Udaa(:,uii)+sda);
        Uda(:,uii)=Udaa(:,uii+1);
    end         
    Uda_top=[0;0];
    for ui=1:10
        Uda_top(:)=Uda_top(:)+Uda(:,ui);
    end
    Uda_ort=Uda_top/ui;
    theta_wda=0.1*Uda(uii);
    theta=0.1*pp;
    if ri>=0.5
        W_r=W_r+mu_r*((Uda_ort+NN)*(Uda(:,uii)-theta_wda)'*(pp-theta))'*f(pp).*rr;
    end
    if max(W_r)>1
        W_r=W_r/max(W_r);
    end
    if (kk==1)
        W_c_i=W_c;
    end
    W_v_all(:,kk)=W_v';         % change in matlab 7.x
    W_c=W_c+mu_c*delta(kk)*action(:,kk)*action(:,kk)';
        
%    [action(:,kk) W_r W_c W_v' [ri; okey]]
    
    h=figure(5);
    hold on, grid on 
    subplot(3,1,1);plot3(W_r(1,1),W_r(2,1),k,'.r');
    zlabel('W_r','fontsize',12,'fontweight','b');
    hold on, grid on
    subplot(3,1,2);plot3(W_c(1,1),W_c(2,1),k,'.b');
    hold on, grid on
    subplot(3,1,2);plot3(W_c(1,2),W_c(2,2),k,'.g');
    zlabel('W_c','fontsize',12,'fontweight','b');
    hold on, grid on
    subplot(3,1,3);plot3(W_v(1,1),W_v(1,2),k,'.k');
    zlabel('W_v','fontsize',12,'fontweight','b');
    if mod(kk,2)==1
        F_W(kf)=getframe(h);
        kf=kf+1;
    end
    
%     if okey == 5                % W'larin degisimi
%         W_diffs(Wdi,:)=[kk W_r' W_c(1,:) W_c(2,:) W_v];
%         Wdi = Wdi+1;
%     end
    if okey>20
%         break
        okey=20;
    end
    W_r_v(:,kk)=W_r(:);
    kk

end

% figure(3)
% hold on
% plot(n,'k','LineWidth',3)
% hold on
% plot(s,'--k','LineWidth',3)
% hold on
% plot(c,':k','LineWidth',3)


figure (2)
subplot(3,1,1); plot(W_r_v(1,:),'r');
subplot(3,1,2); plot(W_r_v(2,:),'g');

subplot(3,1,3); plot(delta) 
title('reinforcement signal - delta')

figure(4)
hold on
plot(delta);
title('reinforcement signal - delta')

% figure(6)
% movie(F_W,2);
movie2avi(F_W,'mov_W.avi');


res=[kk W_r' W_c(1,:) W_c(2,:) W_v ri okey];

% fid=fopen('d:\Program Files\MATLAB\R2009a\work\drtez\nicotine\icann3_yorum_res.txt','a');
% fprintf(fid, '%4.4f', res);
% fprintf(fid, '\r\n');
% fclose(fid);
% fid=fopen('D:\Program Files\MATLAB\R2009a\work\drtez\nicotine\icann3_yorum_res.txt','r');
% readres=fscanf(fid, '%f');
% fclose(fid);
% readres=readres';
% l=1;
% for i=1:(length(readres)/11)
% 	for j=1:11
% 		sonuc(i,j)=readres(l);
% 		l=l+1;
% 	end
% end
% l=1; k=1;
% for i=1:length(sonuc)
%     if sonuc(i,10)==21
%         bagimli(l,:)=sonuc(i,:);
%         l=l+1;
%     else
%         bagimsiz(k,:)=sonuc(i,:);
%         k=k+1;
%     end
% end
